;*********************************************************************************************
; Dateiname 	: 	SD_SCHILLER_Atribute.lsp
; Autor         : 	Stephan Wrz
; Erstellt      :	15.07.2006
; gendert    	:
;*********************************************************************************************
; Beschreibung:		- 	AttributeTool / Lightversion
;
;*********************************************************************************************
; nderungen/Hinweise
;
;*********************************************************************************************
;(in-package :teo) 
(use-package :oli)

;;================================================================================================
;;=========== VOREINSTELLUNGEN ===================================================================
;;================================================================================================

;Die Variable "COMPANY" steuert die Voreinstellung dr die ToggleButtons 'Prfix bei Browserbenennung'

	
(sd-defdialog 'SD_SCHILLER_Atribute
  :dialog-title   "ATTRIBUTE"
  :toolbox-button t
  :start-variable 'object

;;================================================================================================
;;=========== VARIABLEN ==========================================================================
;;================================================================================================

  :variables'(
 
 ("Teil waehlen")
  
(OBJECT
      :value-type    :part-assembly
      :initial-value 	nil
      :size 			:third
      :modifies 		nil
      :title         "Objekt"
      :prompt-text   "Teil/Baugr. auswhlen"
      :after-input
       	(progn
;			(maskezu) 
          	(attriholen)
          	(maske)  
       	); end progn
   ); end OBJECT

("Browserfarbe")
 
(BrowserBlue  
	:toggle-type :wide-toggle
	:push-action 
    	(progn
    		(OhneAttri)
    		(browserfunk)
    		(sd-browser-exec-cmd "parcel-gbrowser"  :REFRESH-TREE)
    	); Ende progn            
	:title "CHECK PARTS !!!"
);end BrowserBlue

("Alle Teile ohne Attribute")
("- Benennung")
("- Typ")
("werden BLAU angezeigt")
	        	
(BrowserBlack	
	:toggle-type :wide-toggle	
	:push-action 
    	(progn
			(allesschwarz)
			(browserfunk)
			(sd-browser-exec-cmd "parcel-gbrowser"  :REFRESH-TREE)
      	); Ende progn            
	:title "ALLES SCHWARZ" 
);end BrowserBlack

(Lesa_HLZ_Artikel
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "Lesa_txt_HLZ_Artikel" :text Lesa_HLZ_Artikel)     
;           (maske)
          ); end progn
      :size :third
      :value-type    :string
      :title         "Artikel"
      :prompt-text   "Artikel waehlen"
    ); end Lesa_HLZ_Artikel


(Lesa_HLZ_Benennung
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "Lesa_txt_HLZ_Benennung" :text Lesa_HLZ_Benennung)     
;           (maske)
          );progn
      :size :third
      :value-type    :string
      :title         "Benennung"
      :prompt-text   "Benennung waehlen"
    ); end Lesa_HLZ_Benennung


(Lesa_HLZ_Typ
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "Lesa_txt_HLZ_Typ" :text Lesa_HLZ_Typ)     
;           (maske)
          );progn
      :size :third
      :value-type    :string
      :title         "Typ"
      :prompt-text   "Typ waehlen"
    ); end Lesa_HLZ_Typ


(Lesa_HLZ_Werkstoff
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "Lesa_txt_HLZ_Werkstoff" :text Lesa_HLZ_Werkstoff)     
;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "Werkstoff"
      :prompt-text   "Werkstoff waehlen"
    )


(Lesa_HLZ_NORM
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "Lesa_txt_HLZ_NORM" :text Lesa_HLZ_NORM)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "NORM"
      :prompt-text   "NORM waehlen"
    )


(Lesa_HLZ_Hersteller
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "Lesa_txt_HLZ_hersteller" :text Lesa_HLZ_Hersteller)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "Hersteller"
      :prompt-text   "Hersteller waehlen"
    )

(LESA_OBERFLAECHE
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_LESA_OBERFLAECHE" :text LESA_OBERFLAECHE)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "OBERFLAECHE"
      :prompt-text   "OBERFLAECHE waehlen"
    )
    
(LESA_WAERMEBEH
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_LESA_WAERMEBEH" :text LESA_WAERMEBEH)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "WAERMEBEHANDLUNG"
      :prompt-text   "WAERMEBEHANDLUNG waehlen"
    )

(LESA_LAENGE
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_LESA_LAENGE" :text LESA_LAENGE)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "ABMESSUNG"
      :prompt-text   "ABMESSUNG waehlen"
    )

(LESA_FREMDNUMMER
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_LESA_FREMDNUMMER" :text LESA_FREMDNUMMER)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "FREMDNUMMER"
      :prompt-text   "FREMDNUMMER waehlen"
    )

(LESA_SCHLUESSEL
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_LESA_SCHLUESSEL" :text LESA_SCHLUESSEL)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "SCHLUESSEL"
      :prompt-text   "SCHLUESSEL waehlen"
    )

(ERSTPROJEKT
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_ERSTPROJEKT" :text ERSTPROJEKT)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "ERSTPROJEKT"
      :prompt-text   "ERSTPROJEKT angeben"
    )

(LESA_URSPRUNG
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_LESA_URSPRUNG" :text LESA_URSPRUNG)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "URSPRUNG"
      :prompt-text   "URSPRUNG angeben"
    )

(ZUSATZ_1
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_ZUSATZ_1" :text ZUSATZ_1)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "ZUSATZ_1"
      :prompt-text   "ZUSATZ_1 angeben"
    )

(ZUSATZ_2
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_ZUSATZ_2" :text ZUSATZ_2)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "ZUSATZ_2"
      :prompt-text   "ZUSATZ_2 angeben"
    )

(BEMERKUNG
      :initial-optional :true
      :initial-visible nil      
      :after-input 
         (progn
           (sd-set-text-control-value "TC_BEMERKUNG" :text BEMERKUNG)     
 ;           (maske)
         );progn
      :size :third
      :value-type    :string
      :title         "BEMERKUNG"
      :prompt-text   "BEMERKUNG angeben"
    )

(FLAG
      :initial-optional :true
      :initial-visible nil 
      :initial-value "HLZ"     
      :size :third
      :value-type    :string
      :title         "HZL_FLAG"
      :prompt-text   "HZL_FLAG waehlen"
    )

(COMPANY
      :initial-optional :true
      :initial-visible nil 
      :initial-value "SCHILLER" ; "MACOM"  "LESATECH"  
      :size :third
      :value-type    :string
);end COMPANY


)  ;end variables

;;================================================================================================
;;=========== FUNKTIONEN =========================================================================
;;================================================================================================

:local-functions
'(
;;===========================================
(attriholen ()

	(setq Lesa_HLZ_Artikel 		(bomattr-get-lesa_HLZ_Artikel 		object))           
	(setq Lesa_HLZ_Benennung 	(bomattr-get-lesa_HLZ_Benennung 	object))         
	(setq Lesa_HLZ_Typ 			(bomattr-get-lesa_HLZ_Typ 			object))         
	(setq Lesa_HLZ_Werkstoff 	(bomattr-get-lesa_HLZ_Werkstoff 	object))                                          
	(setq Lesa_HLZ_NORM 		(bomattr-get-lesa_HLZ_NORM 			object))     
	(setq Lesa_HLZ_hersteller 	(bomattr-get-lesa_HLZ_hersteller 	object))                                   
	(setq LESA_OBERFLAECHE 		(bomattr-get-LESA_OBERFLAECHE 		object))                                   
	(setq LESA_WAERMEBEH 		(bomattr-get-LESA_WAERMEBEH 		object))                                   
	(setq LESA_LAENGE	 		(bomattr-get-LESA_LAENGE 			object))                                   
	(setq LESA_FREMDNUMMER	 	(bomattr-get-LESA_FREMDNUMMER 		object))                                   
	(setq LESA_SCHLUESSEL	 	(bomattr-get-LESA_SCHLUESSEL 		object))                                   
	(setq ERSTPROJEKT	 		(bomattr-get-ERSTPROJEKT 			object))                                   
	(setq LESA_URSPRUNG	 		(bomattr-get-LESA_URSPRUNG	 		object))                                   
	(setq ZUSATZ_1	 			(bomattr-get-ZUSATZ_1 				object))                                   
	(setq ZUSATZ_2	 			(bomattr-get-ZUSATZ_2 				object))                                   
	(setq BEMERKUNG	 			(bomattr-get-BEMERKUNG 				object))                                   
;	(setq FLAG	 				(bomattr-get-FLAG 					object))                                   

); end attriholen
;;===========================================
;;;;(AttriLoeschen ()
;;;;	(setq Lesa_HLZ_Artikel 		"")
;;;;	(setq Lesa_HLZ_Benennung 	"")
;;;;	(setq Lesa_HLZ_Typ 			"")
;;;;	(setq Lesa_HLZ_Werkstoff 	"")
;;;;	(setq Lesa_HLZ_NORM 		"")
;;;;	(setq Lesa_HLZ_hersteller 	"")	
;;;;	(setq LESA_OBERFLAECHE 		"")	
;;;;	(setq LESA_WAERMEBEH 		"")		
;;;;	(setq LESA_LAENGE 			"")	
;;;;	(setq LESA_FREMDNUMMER   	"")	
;;;;	(setq LESA_SCHLUESSEL		"")	
;;;;	(setq ERSTPROJEKT   		"")	
;;;;	(setq LESA_URSPRUNG	    	"")	
;;;;	(setq ZUSATZ_1	    		"")	
;;;;	(setq ZUSATZ_2	    		"")	
;;;;	(setq BEMERKUNG	    		"")	
;;;;		
;;;;); end AttriLoeschen
;;===========================================
(abgleichen ()
	(setq Lesa_HLZ_Artikel 		(sd-get-text-control-value 	"Lesa_txt_HLZ_Artikel"		)) 
	(setq Lesa_HLZ_Benennung 	(sd-get-text-control-value 	"Lesa_txt_HLZ_Benennung"	)) 
	(setq Lesa_HLZ_Typ 			(sd-get-text-control-value 	"Lesa_txt_HLZ_Typ"			)) 
	(setq Lesa_HLZ_Werkstoff 	(sd-get-text-control-value 	"Lesa_txt_HLZ_Werkstoff"	)) 
	(setq Lesa_HLZ_NORM 		(sd-get-text-control-value 	"Lesa_txt_HLZ_NORM"			)) 
	(setq Lesa_HLZ_hersteller 	(sd-get-text-control-value 	"Lesa_txt_HLZ_hersteller"	)) 
	(setq LESA_OBERFLAECHE 		(sd-get-text-control-value 	"TC_LESA_OBERFLAECHE"		)) 
	(setq LESA_WAERMEBEH 		(sd-get-text-control-value 	"TC_LESA_WAERMEBEH"			)) 
	(setq LESA_LAENGE 			(sd-get-text-control-value 	"TC_LESA_LAENGE"			)) 
	(setq LESA_FREMDNUMMER   	(sd-get-text-control-value 	"TC_LESA_FREMDNUMMER"		)) 
	(setq LESA_SCHLUESSEL		(sd-get-text-control-value 	"TC_LESA_SCHLUESSEL"		)) 
	(setq ERSTPROJEKT   		(sd-get-text-control-value 	"TC_ERSTPROJEKT"			)) 
	(setq LESA_URSPRUNG	    	(sd-get-text-control-value 	"TC_LESA_URSPRUNG"			)) 
	(setq ZUSATZ_1	    		(sd-get-text-control-value 	"TC_ZUSATZ_1"				)) 
	(setq ZUSATZ_2	    		(sd-get-text-control-value 	"TC_ZUSATZ_2"				)) 
	(setq BEMERKUNG	    		(sd-get-text-control-value 	"TC_BEMERKUNG"				))

);end abgleichen
;;===========================================
(maskezu ()
     (sd-hide-dialog-shell "UICT-TEST" :ignorePin t )
);end maskezu
;;===========================================
(attrisetzen ()		;;=========== Attribute an OBJECT schreiben ===========
 
	(sd-attach-item-attribute object "LESATECH_BOM_ATTR"
     :attachment :contents 
     :on-copy    :maintain
     :on-merge   :maintain
     :on-split   :detach 
     :on-xform   :maintain
     :filing     '(:sd-file)
     :values `(
	   	:Lesa_HLZ_Artikel 		, Lesa_HLZ_Artikel                                            
       	:Lesa_HLZ_Benennung 	, Lesa_HLZ_Benennung
       	:Lesa_HLZ_Typ 			, Lesa_HLZ_Typ
       	:Lesa_HLZ_Werkstoff 	, Lesa_HLZ_Werkstoff
       	:Lesa_HLZ_NORM 			, Lesa_HLZ_NORM
       	:Lesa_HLZ_Hersteller 	, Lesa_HLZ_Hersteller                                            
       	:LESA_OBERFLAECHE 		, LESA_OBERFLAECHE     
       	:LESA_WAERMEBEH 		, LESA_WAERMEBEH           	                                       
       	:LESA_LAENGE 			, LESA_LAENGE 
 		:LESA_FREMDNUMMER       , LESA_FREMDNUMMER    
 		:LESA_SCHLUESSEL	    , LESA_SCHLUESSEL	 
 		:ERSTPROJEKT          	, ERSTPROJEKT    
 		:LESA_URSPRUNG	        , LESA_URSPRUNG	     
 		:ZUSATZ_1	          	, ZUSATZ_1	     
 		:ZUSATZ_2	          	, ZUSATZ_2	     
 		:BEMERKUNG	          	, BEMERKUNG	     
		:FLAG 					, FLAG                                                          
     ); end values
    ); end sd-attach-item-attribute
);end attrisetzten
;;===========================================
(maske ()


(sd-create-dialog-shell "UICT-TEST" 
                        :title           "Schiller Attributverwaltung"
                        :bottomLine	:ok-cancel-help 
                        :margin 2
                        :helpAction
							'(progn
    							(sd-display-url ( Format NIL "~A/SD_Attribute.htm" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SCHILLERHELPDIR"))))
								); end progn
      
); end sd-create-dialog-shell

(sd-append-area "UICT-TEST-1-AA" "UICT-TEST-AA"
    :frame            t
    :title            "SCHILLER BOM"
	:margin          5
    :titleForeground  "#ffff00"
    :background       :option
)

;;================================================================================================
;;=========== GridArea 'sonstige Attribute' ========= GridArea 'Stuecklisteneintraege ============
;;================================================================================================
  (sd-append-grid-area "Eingabemaske" "UICT-TEST-1-AA"
      :frame t
      :title "Stuecklisteneintraege"
      :spacing 1
      :margin 4
      :cellSize 10,12
      :width  273
      :height 245
  )


;;================================================================================================
;;=========== Textfelder 'TextControls' ========= GridArea 'Stuecklisteneintraege ================
;;================================================================================================

    (sd-create-text-control "Lesa_txt_HLZ_Artikel" "Eingabemaske"
     :x 11
	 :y 0
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

    (sd-create-text-control "Lesa_txt_HLZ_Benennung" "Eingabemaske"
     :x 11
	 :y 2
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

    (sd-create-text-control "Lesa_txt_HLZ_Typ" "Eingabemaske"
     :x 11
	 :y 4
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

    (sd-create-text-control "Lesa_txt_HLZ_Werkstoff" "Eingabemaske"
     :x 11
	 :y 6
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

    (sd-create-text-control "Lesa_txt_HLZ_NORM" "Eingabemaske"
     :x 11
	 :y 8
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

    (sd-create-text-control "Lesa_txt_HLZ_hersteller" "Eingabemaske"
     :x 11
	 :y 10
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_LESA_OBERFLAECHE" "Eingabemaske"
     :x 11
	 :y 12
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_LESA_WAERMEBEH" "Eingabemaske"
     :x 11
	 :y 14
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn (abgleichen))
	 :enterAction '(progn (abgleichen))
	):end

   (sd-create-text-control "TC_LESA_LAENGE" "Eingabemaske"
     :x 11
	 :y 16
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))
(sd-set-text-control-value 	"Lesa_txt_HLZ_Artikel" 		:text 	Lesa_HLZ_Artikel	)
(sd-set-text-control-value 	"Lesa_txt_HLZ_Benennung" 	:text 	Lesa_HLZ_Benennung	)
(sd-set-text-control-value 	"Lesa_txt_HLZ_Typ" 			:text 	Lesa_HLZ_Typ		)
(sd-set-text-control-value 	"Lesa_txt_HLZ_Werkstoff" 	:text 	Lesa_HLZ_Werkstoff	)
(sd-set-text-control-value 	"Lesa_txt_HLZ_NORM" 		:text 	Lesa_HLZ_NORM		)
(sd-set-text-control-value 	"Lesa_txt_HLZ_hersteller" 	:text 	Lesa_HLZ_hersteller	)
(sd-set-text-control-value 	"TC_LESA_OBERFLAECHE"		:text 	LESA_OBERFLAECHE	)
(sd-set-text-control-value 	"TC_LESA_WAERMEBEH"			:text 	LESA_WAERMEBEH		)
(sd-set-text-control-value 	"TC_LESA_LAENGE" 			:text 	LESA_LAENGE			)


;;================================================================================================
;;=========== Schaltflaechen 'PushButton' ========= GridArea 'Stuecklisteneintraege ==============
;;================================================================================================

(sd-create-pushbutton-control "Lesa_HLZ_Artikel" "Eingabemaske"
     :x 0
	 :y 0
	 :width 11
	 :height 2
	 :title "ARTIKEL-NR:"
	 :pushAction '(progn
	 				(sd-show-display-table "DT_Lesa_HLZ_Artikel")
	 ))	 


(sd-create-pushbutton-control "Lesa_HLZ_Benennung" "Eingabemaske"
     :x 0
	 :y 2
	 :width 11
	 :height 2
	 :title "BENENNUNG:"
	 :pushAction '(progn
	 				(sd-show-display-table "DT_Lesa_HLZ_Benennung")
	 ))	 

(sd-create-pushbutton-control "Lesa_HLZ_Typ" "Eingabemaske"
     :x 0
	 :y 4
	 :width 11
	 :height 2
	 :title "TYP:"
	 :pushAction '(progn
	      (sd-show-display-table "DT_Lesa_HLZ_Typ")
	 ))	 

(sd-create-pushbutton-control "Lesa_HLZ_Werkstoff" "Eingabemaske"
     :x 0
	 :y 6
	 :width 11
	 :height 2
	 :title "WERKSTOFF:"
	 :pushAction 	'(progn
	      (sd-show-display-table "DT_Lesa_HLZ_Werkstoff")
	 ))	 

(sd-create-pushbutton-control "Lesa_HLZ_NORM" "Eingabemaske"
     :x 0
	 :y 8
	 :width 11
	 :height 2
	 :title "NORM:"
	 :pushAction 	'(progn
	 	  (sd-show-display-table "DT_Lesa_HLZ_NORM")
	 ))	 


(sd-create-pushbutton-control "Lesa_HLZ_Hersteller" "Eingabemaske"
     :x 0
	 :y 10
	 :width 11
	 :height 2
	 :title "HERSTELLER:"
	 :pushAction '(progn
	      (sd-show-display-table "DT_Lesa_HLZ_Hersteller")	 
	 ))	 

(sd-create-pushbutton-control "LESA_OBERFLAECHE" "Eingabemaske"
     :x 0
	 :y 12
	 :width 11
	 :height 2
	 :title "OBERFLAECHE:"
	 :pushAction '(progn
	      (sd-show-display-table "DT_LESA_OBERFLAECHE")	 
	 ))	 

(sd-create-pushbutton-control "LESA_WAERMEBEH" "Eingabemaske"
     :x 0
	 :y 14
	 :width 11
	 :height 2
	 :title "WAERMEBEH.:"
	 :pushAction '(progn
	      (sd-show-display-table "DT_LESA_WAERMEBEH")	 
	 ))	 

(sd-create-pushbutton-control "LESA_LAENGE" "Eingabemaske"
     :x 0
	 :y 16
	 :width 11
	 :height 2
	 :title "ABMESSUNG:"
	 :pushAction '(progn
	      (sd-show-display-table "DT_LESA_LAENGE")	 	 
	 ))	 


;;================================================================================================
;;=========== GridArea 'sonstige Attribute' ======================================================
;;================================================================================================

;nchstes Grid unterhalb!
	(sd-append-newline "UICT-TEST-1-AA")

  	(sd-append-grid-area "Attribute" "UICT-TEST-1-AA"
      :frame t
      :title "sonstige Attribute"
      :spacing 1
      :margin 4
      :cellSize 10,12
      :width  273
      :height 200
  )
;;================================================================================================
;;=========== Textfelder 'TextControls' ======== GridArea 'sonstige Attribute'====================
;;================================================================================================
   (sd-create-text-control "TC_LESA_FREMDNUMMER" "Attribute"
     :x 11
	 :y 0
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :showFocus t
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_LESA_SCHLUESSEL" "Attribute"
     :x 11
	 :y 2
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :showFocus t
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_ERSTPROJEKT" "Attribute"
     :x 11
	 :y 4
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :showFocus t
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_LESA_URSPRUNG" "Attribute"
     :x 11
	 :y 6
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :showFocus t
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_ZUSATZ_1" "Attribute"
     :x 11
	 :y 8
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :showFocus t
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_ZUSATZ_2" "Attribute"
     :x 11
	 :y 10
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :showFocus t
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

   (sd-create-text-control "TC_BEMERKUNG" "Attribute"
     :x 11
	 :y 12
	 :width 15
	 :height 2
	 :editable t
	 :showModified nil
	 :showFocus t
	 :killFocusAction '(progn 
	 			(abgleichen)
	 			)
	 :enterAction '(progn 
	 		(abgleichen)
	 		))

(sd-set-text-control-value 	"TC_LESA_FREMDNUMMER"		:text 	LESA_FREMDNUMMER 	)
(sd-set-text-control-value 	"TC_LESA_SCHLUESSEL"		:text 	LESA_SCHLUESSEL		)
(sd-set-text-control-value 	"TC_ERSTPROJEKT"			:text 	ERSTPROJEKT 		)
(sd-set-text-control-value 	"TC_LESA_URSPRUNG"			:text 	LESA_URSPRUNG		)
(sd-set-text-control-value 	"TC_ZUSATZ_1"				:text 	ZUSATZ_1			)
(sd-set-text-control-value 	"TC_ZUSATZ_2"				:text 	ZUSATZ_2			)
(sd-set-text-control-value 	"TC_BEMERKUNG"				:text 	BEMERKUNG			)





;;================================================================================================
;;=========== Schaltflaechen 'PushButtons ======== GridArea 'sonstige Attribute' =================
;;================================================================================================

(sd-create-pushbutton-control "LESA_FREMDNUMMER" "Attribute"
     :x 0
	 :y 0
	 :width 11
	 :height 2
	 :title "FREMDNUMMER:"
	 :pushAction '(progn
	 ))	 

(sd-create-pushbutton-control "LESA_SCHLUESSEL" "Attribute"
     :x 0
	 :y 2
	 :width 11
	 :height 2
	 :title "SCHLUESSEL:"   
	 :pushAction '(progn
	    (sd-show-display-table "DT_LESA_SCHLUESSEL")	 
	 ))	  

(sd-create-pushbutton-control "Erstprojekt" "Attribute"
     :x 0
	 :y 4
	 :width 11
	 :height 2
	 :title "ERSTPROJEKT:"
	 :pushAction '(progn
	 ))	 

(sd-create-pushbutton-control "LESA_URSPRUNG" "Attribute"
     :x 0
	 :y 6
	 :width 11
	 :height 2
	 :title "URSPRUNG:"
	 :pushAction '(progn
	 ))	 
	 

(sd-create-pushbutton-control "Zusatz_1" "Attribute"
     :x 0
	 :y 8
	 :width 11
	 :height 2
	 :title "ZUSATZ_1:"
	 :pushAction '(progn
	 ))	 

(sd-create-pushbutton-control "Zusatz_2" "Attribute"
     :x 0
	 :y 10
	 :width 11
	 :height 2
	 :title "ZUSATZ_2:"
	 :pushAction '(progn
	 ))	 

(sd-create-pushbutton-control "Bemerkung" "Attribute"
     :x 0
	 :y 12
	 :width 11
	 :height 2
	 :title "BEMERKUNG:"
	 :pushAction '(progn
	 ))	 


;;================================================================================================
;;=========== GridArea 'Befehle' ======================================================
;;================================================================================================
  
;nchstes Grid unterhalb!
	(sd-append-newline "UICT-TEST-1-AA")

  	(sd-append-grid-area "Befehle" "UICT-TEST-1-AA"
      :frame t
      :title "Befehle"
      :spacing 1
      :margin 4
      :cellSize 10,12
      :width  273
      :height 80
	)
;;================================================================================================
;;=========== Schaltflaechen 'PushButtons ======== GridArea 'Befehle' ============================
;;================================================================================================
	 
(sd-create-pushbutton-control "Lesa_pb_Schliessen" "Befehle"
     	:x 0
	    :y 0
	    :width 26
	    :height 2
	    :title "Schliessen"
	    :pushAction
	    	'(progn
				(maskezu)
	    	);end progn
);end PBC	
	    
(sd-create-pushbutton-control "PBC_Attriesetzen" "Befehle"
     	:x 0
	    :y 2
	    :width 26
	    :height 2
	    :title "Attribute setzen / Fenster schliessen"
	    :pushAction 
	    	'(progn
	         	(abgleichen)
	         	(attrisetzen)
	         	(maskezu)
				(if (sd-togglebutton-set-p "BROWSER-TB") (browserbenennung))    ; wenn 'BROWSER-TB' angehakt dann 'Browserbenennung'
	         ) ;end progn			         				        	         			    	         
); end PBC 

;;================================================================================================
;;=========== GridArea 'Optionen' ================================================================
;;================================================================================================
 
;nchstes Grid unterhalb!
	(sd-append-newline "UICT-TEST-1-AA")

(sd-append-grid-area "OPTIONEN" "UICT-TEST-1-AA"
      :frame t
      :title "OPTIONEN"
      :spacing 1
      :margin 4
      :cellSize 10,12
      :width  273
      :height 95
);end

;;================================================================================================
;;=========== Schaltflaechen 'ToggleButtons ======== GridArea 'Optionen' =========================
;;================================================================================================
  
(sd-create-togglebutton-control "BROWSER-TB" "OPTIONEN"
    :x  0
    :y  0
    :width 12
    :height 2
    :indicator :check
    :title  "Browser umbenennen"
);end

(sd-create-togglebutton-control "SCHI-TB" "OPTIONEN"
    :x  16
    :y  0
    :width 10
    :height 2
    :indicator :check ;:radio ;:none 
    :title  "SCHILLER"
    :pushAction 
    	'(progn
    		(sd-reset-togglebutton "MCO-TB")
			(sd-reset-togglebutton "LESATECH-TB")
			(sd-reset-togglebutton "BROWSER-TB")
		);end progn	    		
    
);end	

(sd-create-togglebutton-control "LESATECH-TB" "OPTIONEN"
    :x  16
    :y  2
    :width 10
    :height 2
    :indicator :check ;:radio ;:none 
    :title  "LESATECH"
    :pushAction 
    	'(progn
    		(sd-reset-togglebutton "MCO-TB")
			(sd-reset-togglebutton "SCHI-TB")
			(sd-set-togglebutton "BROWSER-TB")
		);end progn	    		
);end
	
(sd-create-togglebutton-control "MCO-TB" "OPTIONEN"
    :x  16
    :y  4
    :width 10
    :height 2
    :indicator :check ;:radio ;:none 
    :title  "MCO"
    :pushAction      
    	'(progn
    		(sd-reset-togglebutton "LESATECH-TB")
			(sd-reset-togglebutton "SCHI-TB")
			(sd-set-togglebutton "BROWSER-TB")
		);end progn	    		
);end   


  (if (equal COMPANY "SCHILLER") 	(sd-set-togglebutton "SCHI-TB" 		:callAction t))  
  (if (equal COMPANY "LESATECH")  	(sd-set-togglebutton "LESATECH-TB" 	:callAction t)) 
  (if (equal COMPANY "LESATECH")  	(sd-set-togglebutton "BROWSER-TB" 	:callAction t))                                   
  (if (equal COMPANY "MACOM")  		(sd-set-togglebutton "MCO-TB" 		:callAction t))                                    
  (if (equal COMPANY "MACOM")  		(sd-set-togglebutton "BROWSER-TB"	:callAction t))


  
 
; Zeigt Dialog "UICT-TEST" an
(sd-show-dialog-shell "UICT-TEST" 
:position '("TOP-MENU-TOOLBOX-TB" :bottomleft 160 0))


	   	      
);end maske		
;;=========================================== 

(browserbenennung ()
        		 
	(if (sd-togglebutton-set-p "LESATECH-TB")	(setq Fix "LESA"	)) 	; wenn LESATECH-TB angehakt dann Fix = "LESA"	
	(if (sd-togglebutton-set-p "MCO-TB") 		(setq Fix "MCO"		))  ; wenn MCO-TB angehakt dann Fix = "MCO"
	(if (sd-togglebutton-set-p "SCHI-TB") 		(setq Fix "SCHI"	))  ; wenn SCHI-TB angehakt dann Fix = "SCHI"
;	(setq Fix "SCHI")
    (if (equal Lesa_HLZ_Artikel "") 		(setq Lesa_HLZ_Artikel "ohne_ArtNr"		))              
    (if (equal Lesa_HLZ_Benennung "") 		(setq Lesa_HLZ_Benennung "--"			))		; wenn Lesa_HLZ_Benennung = "" dann Lesa_HLZ_Benennung = "--" 
    (if (equal Lesa_HLZ_Typ "") 			(setq Lesa_HLZ_Typ "--"					))        
    (setq alt (format nil "~A_~A_~A_~A" Fix Lesa_HLZ_Artikel Lesa_HLZ_Benennung Lesa_HLZ_Typ))

    (setq alt (sd-string-replace alt "" "ae"			))	;sd-string-replace = Ersetzt hier im String 'alt' alle '' durch 'ae' und schreibt den modifizierten String wieder in die Variable 'alt'
    (setq alt (sd-string-replace alt "" "oe"			))
    (setq alt (sd-string-replace alt "" "ue"			))
    (setq alt (sd-string-replace alt "" "ae"			))
    (setq alt (sd-string-replace alt "" "oe"			))
    (setq alt (sd-string-replace alt "" "ue"			))
    (setq alt (sd-string-replace alt "" "Ae"			))
    (setq alt (sd-string-replace alt "" "Oe"			))
    (setq alt (sd-string-replace alt "" "Ue"			))
    (setq alt (sd-string-replace alt "+" "-"			))
    (setq alt (sd-string-replace alt "" "-"			))
    (setq alt (sd-string-replace alt " " "_"			))
    (setq alt (sd-string-replace alt "/" "_"			))
    (setq alt (sd-string-replace alt "&" "_"			))
    (setq alt (sd-string-replace alt "_-_" "-"			))
   	(setq alt (sd-string-replace alt "___" "_"			))
    (setq alt (sd-string-replace alt "__" "_"			))
    (setq alt (sd-string-replace alt "," "."			))
    (setq alt (sd-string-replace alt ".-" "-"			))
    (setq alt (sd-string-replace alt "-." "-"			))
    (setq alt (sd-string-replace alt "NIL" ".--."		))
    (setq alt (sd-string-replace alt "nil" ".--."		))
    
    (setq pfad (sd-inq-obj-pathname object				))	; Pfad von 'OBJECT' im 'Browserpfad'
    (setq pname (sd-inq-obj-basename object      		)) 	; Name von 'OBJECT' im Browser 'Browserbenennung'
    (setq conttest (sd-inq-obj-contents-name object	))  	; Contents-Name von 'OBJECT'      
    
;    (setq baugruppe (sd-string-replace pfad pname ""	))	; Baugruppe = vom Pfad den Objectnamen abziehen 'durch "" ersetzen'
     

    (setq alt (format nil "~A." alt))
	(setq AlleObjects (sd-inq-obj-shared-objects object		))	; whlt alle Exemplare von 'OBJECT'

     	(let
      		((n (length AlleObjects))
       			(i 0))
         			(dolist
           				(part AlleObjects)
              			(progn
                		(setq nameval (sd-gen-obj-basename :part :parent (sd-inq-parent-obj part) :prefix alt))
                		(change_name_pa :part_asmb part :name nameval)                            
               			);endprogn	       
       				(incf i)
       				); end dolist
     	);end let 
	(sd-show-graphical-browser "parcel-gbrowser" )	;erzwingt neuen Aufbau des Browsers
	);end browserbenennung 
	
	
(OhneAttri ()
	(defun my-color-interrogator (node name)
		(declare (ignore name))
		(setf name (sd-pathname-to-obj(BrowserNode-objPath node)))
		(when (AND name (OR (sd-inq-part-p name)(sd-inq-assembly-p name)))
			(cond 
    	   		((sd-string= (sd-inq-item-attribute name "LESATECH_BOM_ATTR" :Lesa_HLZ_Benennung  	:attachment :contents) nil)  		"#0000FF" )
    	   		((sd-string= (sd-inq-item-attribute name "LESATECH_BOM_ATTR" :Lesa_HLZ_Benennung  	:attachment :contents) "")  		"#0000FF" )
		   		((sd-string= (sd-inq-item-attribute name "LESATECH_BOM_ATTR" :Lesa_HLZ_Typ  		:attachment :contents) nil)  		"#0000FF" )
		   		((sd-string= (sd-inq-item-attribute name "LESATECH_BOM_ATTR" :Lesa_HLZ_Typ  		:attachment :contents) "")  		"#0000FF" )                                         
 			);end cond      
		);end when
	);end defun
);end OhneAttri
         
(allesschwarz ()
	(defun my-color-interrogator (node name)
		(declare (ignore name))
		(let ((objname (BrowserNode-objPath node)))"#000000");end let
	);end defun
);end alles schwarz

  
(browserfunk ()
        (sd-browser-add-interrogator "parcel-gbrowser"
                    :interrogator-type :text-color 
                    :interrogator-func 'my-color-interrogator)
);endbrowserfunk  
  
);endlocalfunk
  
 
:ok-action
	'(progn
  		(maskezu)
);end ok_action


:cancel-action
	'(progn
       	(maskezu)
);end cancel-ACTION

:help-action
	'(progn
    	(sd-display-url ( Format NIL "~A/SD_Attribute.htm" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SCHILLERHELPDIR"))))
		); end progn

);end defdialog

;;-----------------------------------------------------------------------------
;; auslesen bestehender BOM informationen
;;-----------------------------------------------------------------------------



(defun bomattr-get-lesa_HLZ_Artikel (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :Lesa_HLZ_Artikel) nil)
  )
)


(defun bomattr-get-lesa_HLZ_Benennung(selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :Lesa_HLZ_Benennung) nil)
  )
)

(defun bomattr-get-lesa_HLZ_Typ(selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :Lesa_HLZ_Typ) nil)
  )
)

(defun bomattr-get-lesa_HLZ_Werkstoff(selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :Lesa_HLZ_Werkstoff) nil)
  )
)

(defun bomattr-get-lesa_HLZ_NORM(selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :Lesa_HLZ_NORM) nil)
  )
)

(defun bomattr-get-lesa_HLZ_Hersteller (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :Lesa_HLZ_Hersteller) nil)
  )
)

(defun bomattr-get-LESA_OBERFLAECHE (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :LESA_OBERFLAECHE) nil)
  )
)

(defun bomattr-get-LESA_WAERMEBEH (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :LESA_WAERMEBEH) nil)
  )
)

(defun bomattr-get-LESA_LAENGE (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :LESA_LAENGE) nil)
  )
)

(defun bomattr-get-LESA_FREMDNUMMER (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :LESA_FREMDNUMMER) nil)
  )
)

(defun bomattr-get-LESA_SCHLUESSEL (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :LESA_SCHLUESSEL) nil)
  )
)

(defun bomattr-get-ERSTPROJEKT (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :ERSTPROJEKT) nil)
  )
)

(defun bomattr-get-LESA_URSPRUNG (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :LESA_URSPRUNG) nil)
  )
)

(defun bomattr-get-ZUSATZ_1 (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :ZUSATZ_1) nil)
  )
)

(defun bomattr-get-ZUSATZ_2 (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :ZUSATZ_2) nil)
  )
)

(defun bomattr-get-BEMERKUNG (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :BEMERKUNG) nil)
  )
)

(defun bomattr-get-FLAG (selitem)
  (let ((attr (sd-inq-item-attribute selitem "LESATECH_BOM_ATTR"
                                     :values :attachment :contents)))
     (if attr (getf attr :FLAG) nil)
  )
)

;;-----------------------------------------------------------------------------
;; BOM attributes erstellen
;;-----------------------------------------------------------------------------

(defun lesa-bom-attr-HLZ_Artikel (selitem)
  (let ((lesa_HLZ_Artikel (bomattr-get-lesa_HLZ_Artikel selitem)))
    (if lesa_HLZ_Artikel lesa_HLZ_Artikel "")
  )
)
 
 
(defun lesa-bom-attr-HLZ_Benennung (selitem)
  (let ((lesa_HLZ_Benennung (bomattr-get-lesa_HLZ_Benennung selitem)))
    (if lesa_HLZ_Benennung lesa_HLZ_Benennung "")
  )
)

(defun lesa-bom-attr-HLZ_Typ (selitem)
  (let ((lesa_HLZ_Typ (bomattr-get-lesa_HLZ_Typ selitem)))
    (if lesa_HLZ_Typ lesa_HLZ_Typ "")
  )
)

(defun lesa-bom-attr-HLZ_Werkstoff (selitem)
  (let ((lesa_HLZ_Werkstoff (bomattr-get-lesa_HLZ_Werkstoff selitem)))
    (if lesa_HLZ_Werkstoff lesa_HLZ_Werkstoff "")
  )
)

(defun lesa-bom-attr-HLZ_NORM (selitem)
  (let ((lesa_HLZ_NORM (bomattr-get-lesa_HLZ_NORM selitem)))
    (if lesa_HLZ_NORM lesa_HLZ_NORM "")
  )
) 



(defun lesa-bom-attr-HLZ_Hersteller (selitem)
  (let ((lesa_HLZ_Hersteller (bomattr-get-lesa_HLZ_Hersteller selitem)))
    (if lesa_HLZ_Hersteller lesa_HLZ_Hersteller "")
  )
)

(defun lesa-bom-attr-LESA_OBERFLAECHE (selitem)
  (let ((LESA_OBERFLAECHE (bomattr-get-LESA_OBERFLAECHE selitem)))
    (if LESA_OBERFLAECHE LESA_OBERFLAECHE "")
  )
)

(defun lesa-bom-attr-LESA_WAERMEBEH (selitem)
  (let ((LESA_WAERMEBEH (bomattr-get-LESA_WAERMEBEH selitem)))
    (if LESA_WAERMEBEH LESA_WAERMEBEH "")
  )
)

(defun lesa-bom-attr-LESA_LAENGE (selitem)
  (let ((LESA_LAENGE (bomattr-get-LESA_LAENGE selitem)))
    (if LESA_LAENGE LESA_LAENGE "")
  )
)

(defun lesa-bom-attr-LESA_FREMDNUMMER (selitem)
  (let ((LESA_FREMDNUMMER (bomattr-get-LESA_FREMDNUMMER selitem)))
    (if LESA_FREMDNUMMER LESA_FREMDNUMMER "")
  )
)

(defun lesa-bom-attr-LESA_SCHLUESSEL (selitem)
  (let ((LESA_SCHLUESSEL (bomattr-get-LESA_SCHLUESSEL selitem)))
    (if LESA_SCHLUESSEL LESA_SCHLUESSEL "")
  )
)

(defun lesa-bom-attr-ERSTPROJEKT (selitem)
  (let ((ERSTPROJEKT (bomattr-get-ERSTPROJEKT selitem)))
    (if ERSTPROJEKT ERSTPROJEKT "")
  )
)

(defun lesa-bom-attr-LESA_URSPRUNG (selitem)
  (let ((LESA_URSPRUNG (bomattr-get-LESA_URSPRUNG selitem)))
    (if LESA_URSPRUNG LESA_URSPRUNG "")
  )
)

(defun lesa-bom-attr-ZUSATZ_1 (selitem)
  (let ((ZUSATZ_1 (bomattr-get-ZUSATZ_1 selitem)))
    (if ZUSATZ_1 ZUSATZ_1 "")
  )
)

(defun lesa-bom-attr-ZUSATZ_2 (selitem)
  (let ((ZUSATZ_2 (bomattr-get-ZUSATZ_2 selitem)))
    (if ZUSATZ_2 ZUSATZ_2 "")
  )
)

(defun lesa-bom-attr-BEMERKUNG (selitem)
  (let ((BEMERKUNG (bomattr-get-BEMERKUNG selitem)))
    (if BEMERKUNG BEMERKUNG "")
  )
)
 
(defun lesa-bom-attr-FLAG (selitem)
  (let ((FLAG (bomattr-get-FLAG selitem)))
    (if FLAG FLAG "")
  )
)
 
 
                   